/*
 * Copyright 2022 CloudWeGo Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package golang

var file = `{{$ROOT := . -}}
// Code generated by hz.

package {{.PackageName}}

import (
	"fmt"
{{- range $alias, $model := .Imports}}
	{{$model.PackageName}} "{{$model.Package}}"
{{- end}}
)

{{- range .Typedefs}}
{{template "Typedef" .}}
{{- end}}

{{- range .Constants}}
{{template "Constants" .}}
{{- end}}

{{- range .Variables}}
{{template "Variables" .}}
{{- end}}

{{- range .Functions}}
{{template "Function" .}}
{{- end}}

{{- range .Enums}}
{{template "Enum" .}}
{{- end}}

{{- range .Oneofs}}
{{template "Oneof" .}}
{{- end}}

{{- range .Structs}}
{{template "Struct" .}}
{{- end}}

{{- range .Methods}}
{{template "Method" .}}
{{- end}}
`
