/*
 * Copyright 2022 CloudWeGo Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package util

import "testing"

func TestQueryVersion(t *testing.T) {
	lowVersion := "v0.1.0"
	equalVersion := "v0.2.0"
	highVersion := "v0.3.0"

	if ShouldUpdate(lowVersion, ThriftgoMiniVersion) {
	}

	if ShouldUpdate(equalVersion, ThriftgoMiniVersion) {
		t.Fatal("should not be updated")
	}

	if ShouldUpdate(highVersion, ThriftgoMiniVersion) {
		t.Fatal("should not be updated")
	}
}
